// Compiled by ClojureScript 1.9.229 {}
goog.provide('re_com.typeahead');
goog.require('cljs.core');
goog.require('cljs.core.async');
goog.require('re_com.misc');
goog.require('re_com.util');
goog.require('re_com.popover');
goog.require('re_com.box');
goog.require('re_com.validate');
goog.require('reagent.core');
goog.require('goog.events.KeyCodes');
re_com.typeahead.typeahead_args_desc = new cljs.core.PersistentVector(null, 18, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"data-source","data-source",-658934676),new cljs.core.Keyword(null,"required","required",1807647006),true,new cljs.core.Keyword(null,"type","type",1174270348),"fn",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null)," supplies suggestion objects. This can either accept a single string argument (the search term), or a string and a callback. For the first case, the fn should return a collection of suggestion objects (which can be anything). For the second case, the fn should return ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"nil"], null),", and eventually result in a call to the callback with a collection of suggestion objects."], null)], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"on-change","on-change",-732046149),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),null,new cljs.core.Keyword(null,"type","type",1174270348),"string -> nil",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":change-on-blur?"], null)," controls when it is called. It is passed a suggestion object."], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),true,new cljs.core.Keyword(null,"type","type",1174270348),"boolean | atom",new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 8, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"when true, invoke ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":on-change"], null)," when the use chooses a suggestion, otherwise invoke it on every change (navigating through suggestions with the mouse or keyboard, or if ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"rigid?"], null)," is also ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"false"], null),", invoke it on every character typed.)"], null)], null),cljs.core.PersistentArrayMap.fromArray([new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"model","model",331153215),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),null,new cljs.core.Keyword(null,"type","type",1174270348),"object | atom",new cljs.core.Keyword(null,"description","description",-1428560544),"The initial value of the typeahead (should match the suggestion objects returned by ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null),")."], true, false),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"debounce-delay","debounce-delay",-608187982),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),(250),new cljs.core.Keyword(null,"type","type",1174270348),"integer",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.integer_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"After receiving input, the typeahead will wait this many milliseconds without receiving new input before calling ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null),"."], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"render-suggestion","render-suggestion",1472406503),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"render fn",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"override the rendering of the suggestion items by passing a fn that returns hiccup forms. The fn will receive two arguments: the search term, and the suggestion object."], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"suggestion -> string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"When a suggestion is chosen, the input-text value will be set to the result of calling this fn with the suggestion object."], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),true,new cljs.core.Keyword(null,"type","type",1174270348),"boolean | atom",new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"If ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"false"], null)," the user will be allowed to choose arbitrary text input rather than a suggestion from ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null),". In this case, a string will be supplied in lieu of a suggestion object."], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"keyword",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.input_status_type_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"validation status. ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"nil/omitted"], null)," for normal status or one of: ",re_com.validate.input_status_types_list], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"status-icon?","status-icon?",1328423612),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),false,new cljs.core.Keyword(null,"type","type",1174270348),"boolean",new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"when true, display an icon to match ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":status"], null)," (no icon for nil)"], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"status-tooltip","status-tooltip",1912159007),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"displayed in status icon's tooltip"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"placeholder","placeholder",-104873083),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"background text shown when empty"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"width","width",-384071477),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),"250px",new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"standard CSS width setting for this input"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"height","height",1025178622),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"standard CSS height setting for this input"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"disabled?","disabled?",-1523234181),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),false,new cljs.core.Keyword(null,"type","type",1174270348),"boolean | atom",new cljs.core.Keyword(null,"description","description",-1428560544),"if true, the user can't interact (input anything)"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"class","class",-2030961996),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS class names, space separated"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"CSS style map",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.css_style_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS styles to add or override"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"HTML attr map",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.html_attr_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 9, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"HTML attributes, like ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":on-mouse-move"], null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"br","br",934104792)], null),"No ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":class"], null)," or ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":style"], null),"allowed"], null)], null)], null);

/**
 * Return an initial value for the typeahead state, given `args`.
 */
re_com.typeahead.make_typeahead_state = (function re_com$typeahead$make_typeahead_state(p__12877){
var map__12881 = p__12877;
var map__12881__$1 = ((((!((map__12881 == null)))?((((map__12881.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12881.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12881):map__12881);
var args = map__12881__$1;
var on_change = cljs.core.get.call(null,map__12881__$1,new cljs.core.Keyword(null,"on-change","on-change",-732046149));
var rigid_QMARK_ = cljs.core.get.call(null,map__12881__$1,new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118));
var change_on_blur_QMARK_ = cljs.core.get.call(null,map__12881__$1,new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925));
var data_source = cljs.core.get.call(null,map__12881__$1,new cljs.core.Keyword(null,"data-source","data-source",-658934676));
var suggestion_to_string = cljs.core.get.call(null,map__12881__$1,new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962));
var debounce_delay = cljs.core.get.call(null,map__12881__$1,new cljs.core.Keyword(null,"debounce-delay","debounce-delay",-608187982));
var model = cljs.core.get.call(null,map__12881__$1,new cljs.core.Keyword(null,"model","model",331153215));
var external_model_value = re_com.util.deref_or_value.call(null,model);
var G__12883 = (function (){var c_input = cljs.core.async.chan.call(null);
return cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962),new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),new cljs.core.Keyword(null,"input-text","input-text",-1336297114),new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118),new cljs.core.Keyword(null,"data-source","data-source",-658934676),new cljs.core.Keyword(null,"c-search","c-search",1832536180),new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925),new cljs.core.Keyword(null,"suggestions","suggestions",-859472618),new cljs.core.Keyword(null,"c-input","c-input",-1821004232),new cljs.core.Keyword(null,"on-change","on-change",-732046149),new cljs.core.Keyword(null,"external-model","external-model",506095421),new cljs.core.Keyword(null,"model","model",331153215)],[false,(function (){var or__6409__auto__ = suggestion_to_string;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return cljs.core.str;
}
})(),false,"",rigid_QMARK_,data_source,re_com.typeahead.debounce.call(null,c_input,debounce_delay),change_on_blur_QMARK_,cljs.core.PersistentVector.EMPTY,c_input,on_change,re_com.util.deref_or_value.call(null,model),re_com.util.deref_or_value.call(null,model)]);
})();
if(cljs.core.truth_(external_model_value)){
return re_com.typeahead.display_suggestion.call(null,G__12883,external_model_value);
} else {
return G__12883;
}
});
/**
 * Should `event` update the `typeahead` `model`?
 */
re_com.typeahead.event_updates_model_QMARK_ = (function re_com$typeahead$event_updates_model_QMARK_(p__12884,event){
var map__12888 = p__12884;
var map__12888__$1 = ((((!((map__12888 == null)))?((((map__12888.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12888.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12888):map__12888);
var state = map__12888__$1;
var change_on_blur_QMARK_ = cljs.core.get.call(null,map__12888__$1,new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925));
var rigid_QMARK_ = cljs.core.get.call(null,map__12888__$1,new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118));
var change_on_blur_QMARK___$1 = re_com.util.deref_or_value.call(null,change_on_blur_QMARK_);
var rigid_QMARK___$1 = re_com.util.deref_or_value.call(null,rigid_QMARK_);
var G__12890 = (((event instanceof cljs.core.Keyword))?event.fqn:null);
switch (G__12890) {
case "input-text-blurred":
var and__6397__auto__ = change_on_blur_QMARK___$1;
if(cljs.core.truth_(and__6397__auto__)){
return cljs.core.not.call(null,rigid_QMARK___$1);
} else {
return and__6397__auto__;
}

break;
case "suggestion-activated":
return cljs.core.not.call(null,change_on_blur_QMARK___$1);

break;
case "input-text-changed":
return cljs.core.not.call(null,(function (){var or__6409__auto__ = change_on_blur_QMARK___$1;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return rigid_QMARK___$1;
}
})());

break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(event)].join('')));

}
});
/**
 * Should `event` cause the `input-text` value to be used to show the active suggestion?
 */
re_com.typeahead.event_displays_suggestion_QMARK_ = (function re_com$typeahead$event_displays_suggestion_QMARK_(p__12892,event){
var map__12896 = p__12892;
var map__12896__$1 = ((((!((map__12896 == null)))?((((map__12896.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12896.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12896):map__12896);
var state = map__12896__$1;
var change_on_blur_QMARK_ = cljs.core.get.call(null,map__12896__$1,new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925));
var change_on_blur_QMARK___$1 = re_com.util.deref_or_value.call(null,change_on_blur_QMARK_);
var G__12898 = (((event instanceof cljs.core.Keyword))?event.fqn:null);
switch (G__12898) {
case "suggestion-activated":
return cljs.core.not.call(null,change_on_blur_QMARK___$1);

break;
default:
return false;

}
});
/**
 * Change the `typeahead` `model` value to `new-value`
 */
re_com.typeahead.update_model = (function re_com$typeahead$update_model(p__12900,new_value){
var map__12903 = p__12900;
var map__12903__$1 = ((((!((map__12903 == null)))?((((map__12903.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12903.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12903):map__12903);
var state = map__12903__$1;
var on_change = cljs.core.get.call(null,map__12903__$1,new cljs.core.Keyword(null,"on-change","on-change",-732046149));
if(cljs.core.truth_(on_change)){
on_change.call(null,new_value);
} else {
}

return cljs.core.assoc.call(null,state,new cljs.core.Keyword(null,"model","model",331153215),new_value);
});
/**
 * Change the `input-text` `model` to the string representation of `suggestion`
 */
re_com.typeahead.display_suggestion = (function re_com$typeahead$display_suggestion(p__12905,suggestion){
var map__12909 = p__12905;
var map__12909__$1 = ((((!((map__12909 == null)))?((((map__12909.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12909.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12909):map__12909);
var state = map__12909__$1;
var suggestion_to_string = cljs.core.get.call(null,map__12909__$1,new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962));
var suggestion_string = suggestion_to_string.call(null,suggestion);
var G__12911 = state;
if(cljs.core.truth_(suggestion_string)){
return cljs.core.assoc.call(null,G__12911,new cljs.core.Keyword(null,"input-text","input-text",-1336297114),suggestion_string,new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),true);
} else {
return G__12911;
}
});
re_com.typeahead.clear_suggestions = (function re_com$typeahead$clear_suggestions(state){
return cljs.core.dissoc.call(null,state,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618),new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
});
/**
 * Make the suggestion at `index` the active suggestion
 */
re_com.typeahead.activate_suggestion_by_index = (function re_com$typeahead$activate_suggestion_by_index(p__12912,index){
var map__12916 = p__12912;
var map__12916__$1 = ((((!((map__12916 == null)))?((((map__12916.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12916.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12916):map__12916);
var state = map__12916__$1;
var suggestions = cljs.core.get.call(null,map__12916__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion = cljs.core.nth.call(null,suggestions,index);
var G__12918 = state;
var G__12918__$1 = cljs.core.assoc.call(null,G__12918,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728),index)
;
var G__12918__$2 = (cljs.core.truth_(re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"suggestion-activated","suggestion-activated",316961778)))?re_com.typeahead.update_model.call(null,G__12918__$1,suggestion):G__12918__$1);
if(cljs.core.truth_(re_com.typeahead.event_displays_suggestion_QMARK_.call(null,state,new cljs.core.Keyword(null,"suggestion-activated","suggestion-activated",316961778)))){
return re_com.typeahead.display_suggestion.call(null,G__12918__$2,suggestion);
} else {
return G__12918__$2;
}
});
/**
 * Choose the suggestion at `index`
 */
re_com.typeahead.choose_suggestion_by_index = (function re_com$typeahead$choose_suggestion_by_index(p__12919,index){
var map__12922 = p__12919;
var map__12922__$1 = ((((!((map__12922 == null)))?((((map__12922.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12922.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12922):map__12922);
var state = map__12922__$1;
var suggestions = cljs.core.get.call(null,map__12922__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion = cljs.core.nth.call(null,suggestions,index);
return re_com.typeahead.clear_suggestions.call(null,re_com.typeahead.display_suggestion.call(null,re_com.typeahead.update_model.call(null,re_com.typeahead.activate_suggestion_by_index.call(null,state,index),suggestion),suggestion));
});
re_com.typeahead.choose_suggestion_active = (function re_com$typeahead$choose_suggestion_active(p__12924){
var map__12928 = p__12924;
var map__12928__$1 = ((((!((map__12928 == null)))?((((map__12928.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12928.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12928):map__12928);
var state = map__12928__$1;
var suggestion_active_index = cljs.core.get.call(null,map__12928__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var G__12930 = state;
if(cljs.core.truth_(suggestion_active_index)){
return re_com.typeahead.choose_suggestion_by_index.call(null,G__12930,suggestion_active_index);
} else {
return G__12930;
}
});
re_com.typeahead.wrap = (function re_com$typeahead$wrap(index,count){
return cljs.core.mod.call(null,(count + index),count);
});
re_com.typeahead.activate_suggestion_next = (function re_com$typeahead$activate_suggestion_next(p__12931){
var map__12935 = p__12931;
var map__12935__$1 = ((((!((map__12935 == null)))?((((map__12935.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12935.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12935):map__12935);
var state = map__12935__$1;
var suggestions = cljs.core.get.call(null,map__12935__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion_active_index = cljs.core.get.call(null,map__12935__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var G__12937 = state;
if(cljs.core.truth_(suggestions)){
return re_com.typeahead.activate_suggestion_by_index.call(null,G__12937,re_com.typeahead.wrap.call(null,((function (){var or__6409__auto__ = suggestion_active_index;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return (-1);
}
})() + (1)),cljs.core.count.call(null,suggestions)));
} else {
return G__12937;
}
});
re_com.typeahead.activate_suggestion_prev = (function re_com$typeahead$activate_suggestion_prev(p__12938){
var map__12942 = p__12938;
var map__12942__$1 = ((((!((map__12942 == null)))?((((map__12942.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12942.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12942):map__12942);
var state = map__12942__$1;
var suggestions = cljs.core.get.call(null,map__12942__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion_active_index = cljs.core.get.call(null,map__12942__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var G__12944 = state;
if(cljs.core.truth_(suggestions)){
return re_com.typeahead.activate_suggestion_by_index.call(null,G__12944,re_com.typeahead.wrap.call(null,((function (){var or__6409__auto__ = suggestion_active_index;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return (0);
}
})() - (1)),cljs.core.count.call(null,suggestions)));
} else {
return G__12944;
}
});
re_com.typeahead.reset_typeahead = (function re_com$typeahead$reset_typeahead(state){
var G__12946 = state;
var G__12946__$1 = re_com.typeahead.clear_suggestions.call(null,G__12946)
;
var G__12946__$2 = cljs.core.assoc.call(null,G__12946__$1,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),false,new cljs.core.Keyword(null,"input-text","input-text",-1336297114),"",new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),false)
;
if(cljs.core.truth_(re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"input-text-changed","input-text-changed",-1906799535)))){
return re_com.typeahead.update_model.call(null,G__12946__$2,null);
} else {
return G__12946__$2;
}
});
/**
 * Update state when new suggestions are available
 */
re_com.typeahead.got_suggestions = (function re_com$typeahead$got_suggestions(state,suggestions){
return cljs.core.assoc.call(null,state,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618),suggestions,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),false,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728),null);
});
/**
 * Update state when the `input-text` is about to lose focus.
 */
re_com.typeahead.input_text_will_blur = (function re_com$typeahead$input_text_will_blur(p__12947){
var map__12951 = p__12947;
var map__12951__$1 = ((((!((map__12951 == null)))?((((map__12951.cljs$lang$protocol_mask$partition0$ & (64))) || (map__12951.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__12951):map__12951);
var state = map__12951__$1;
var input_text = cljs.core.get.call(null,map__12951__$1,new cljs.core.Keyword(null,"input-text","input-text",-1336297114));
var displaying_suggestion_QMARK_ = cljs.core.get.call(null,map__12951__$1,new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862));
var G__12953 = state;
if(cljs.core.truth_((function (){var and__6397__auto__ = cljs.core.not.call(null,displaying_suggestion_QMARK_);
if(and__6397__auto__){
return re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"input-text-blurred","input-text-blurred",-501892307));
} else {
return and__6397__auto__;
}
})())){
return re_com.typeahead.update_model.call(null,G__12953,input_text);
} else {
return G__12953;
}
});
/**
 * Update `state` given a new `data-source`. Resets the typeahead since any existing suggestions
 *   came from the old `data-source`.
 */
re_com.typeahead.change_data_source = (function re_com$typeahead$change_data_source(state,data_source){
return cljs.core.assoc.call(null,re_com.typeahead.reset_typeahead.call(null,state),new cljs.core.Keyword(null,"data-source","data-source",-658934676),data_source);
});
/**
 * Update state when the external model value has changed.
 */
re_com.typeahead.external_model_changed = (function re_com$typeahead$external_model_changed(state,new_value){
return re_com.typeahead.clear_suggestions.call(null,re_com.typeahead.display_suggestion.call(null,re_com.typeahead.update_model.call(null,state,new_value),new_value));
});
/**
 * Call the `data-source` fn with `text`, and then call `got-suggestions` with the result
 *   (asynchronously, if `data-source` does not return a truthy value).
 */
re_com.typeahead.search_data_source_BANG_ = (function re_com$typeahead$search_data_source_BANG_(data_source,state_atom,text){
var temp__4655__auto__ = data_source.call(null,text,(function (p1__12954_SHARP_){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.got_suggestions,p1__12954_SHARP_);
}));
if(cljs.core.truth_(temp__4655__auto__)){
var return_value = temp__4655__auto__;
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.got_suggestions,return_value);
} else {
return cljs.core.swap_BANG_.call(null,state_atom,cljs.core.assoc,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),true);
}
});
/**
 * For every value arriving on the `c-search` channel, call `search-data-source!`.
 */
re_com.typeahead.search_data_source_loop_BANG_ = (function re_com$typeahead$search_data_source_loop_BANG_(state_atom,c_search){
var c__9975__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto__){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto__){
return (function (state_13004){
var state_val_13005 = (state_13004[(1)]);
if((state_val_13005 === (1))){
var state_13004__$1 = state_13004;
var statearr_13006_13021 = state_13004__$1;
(statearr_13006_13021[(2)] = null);

(statearr_13006_13021[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13005 === (2))){
var state_13004__$1 = state_13004;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13004__$1,(4),c_search);
} else {
if((state_val_13005 === (3))){
var inst_13002 = (state_13004[(2)]);
var state_13004__$1 = state_13004;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13004__$1,inst_13002);
} else {
if((state_val_13005 === (4))){
var inst_12990 = (state_13004[(7)]);
var inst_12990__$1 = (state_13004[(2)]);
var inst_12991 = cljs.core.deref.call(null,state_atom);
var inst_12992 = new cljs.core.Keyword(null,"data-source","data-source",-658934676).cljs$core$IFn$_invoke$arity$1(inst_12991);
var inst_12993 = cljs.core._EQ_.call(null,"",inst_12990__$1);
var state_13004__$1 = (function (){var statearr_13007 = state_13004;
(statearr_13007[(7)] = inst_12990__$1);

(statearr_13007[(8)] = inst_12992);

return statearr_13007;
})();
if(inst_12993){
var statearr_13008_13022 = state_13004__$1;
(statearr_13008_13022[(1)] = (5));

} else {
var statearr_13009_13023 = state_13004__$1;
(statearr_13009_13023[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13005 === (5))){
var inst_12995 = cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.reset_typeahead);
var state_13004__$1 = state_13004;
var statearr_13010_13024 = state_13004__$1;
(statearr_13010_13024[(2)] = inst_12995);

(statearr_13010_13024[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13005 === (6))){
var inst_12990 = (state_13004[(7)]);
var inst_12992 = (state_13004[(8)]);
var inst_12997 = re_com.typeahead.search_data_source_BANG_.call(null,inst_12992,state_atom,inst_12990);
var state_13004__$1 = state_13004;
var statearr_13011_13025 = state_13004__$1;
(statearr_13011_13025[(2)] = inst_12997);

(statearr_13011_13025[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13005 === (7))){
var inst_12999 = (state_13004[(2)]);
var state_13004__$1 = (function (){var statearr_13012 = state_13004;
(statearr_13012[(9)] = inst_12999);

return statearr_13012;
})();
var statearr_13013_13026 = state_13004__$1;
(statearr_13013_13026[(2)] = null);

(statearr_13013_13026[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__9975__auto__))
;
return ((function (switch__8768__auto__,c__9975__auto__){
return (function() {
var re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto__ = null;
var re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto____0 = (function (){
var statearr_13017 = [null,null,null,null,null,null,null,null,null,null];
(statearr_13017[(0)] = re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto__);

(statearr_13017[(1)] = (1));

return statearr_13017;
});
var re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto____1 = (function (state_13004){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_13004);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e13018){if((e13018 instanceof Object)){
var ex__8772__auto__ = e13018;
var statearr_13019_13027 = state_13004;
(statearr_13019_13027[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13004);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13018;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13028 = state_13004;
state_13004 = G__13028;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto__ = function(state_13004){
switch(arguments.length){
case 0:
return re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto____0.call(this);
case 1:
return re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto____1.call(this,state_13004);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto____0;
re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto____1;
return re_com$typeahead$search_data_source_loop_BANG__$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto__))
})();
var state__9977__auto__ = (function (){var statearr_13020 = f__9976__auto__.call(null);
(statearr_13020[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto__);

return statearr_13020;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto__))
);

return c__9975__auto__;
});
/**
 * Update state in response to `input-text` `on-change`, and put text on the `c-input` channel
 */
re_com.typeahead.input_text_on_change_BANG_ = (function re_com$typeahead$input_text_on_change_BANG_(state_atom,new_text){
var map__13033 = cljs.core.deref.call(null,state_atom);
var map__13033__$1 = ((((!((map__13033 == null)))?((((map__13033.cljs$lang$protocol_mask$partition0$ & (64))) || (map__13033.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__13033):map__13033);
var state = map__13033__$1;
var input_text = cljs.core.get.call(null,map__13033__$1,new cljs.core.Keyword(null,"input-text","input-text",-1336297114));
var c_input = cljs.core.get.call(null,map__13033__$1,new cljs.core.Keyword(null,"c-input","c-input",-1821004232));
if(cljs.core._EQ_.call(null,new_text,input_text)){
return state;
} else {
if(clojure.string.blank_QMARK_.call(null,new_text)){
} else {
cljs.core.async.put_BANG_.call(null,c_input,new_text);
}

return cljs.core.swap_BANG_.call(null,state_atom,((function (map__13033,map__13033__$1,state,input_text,c_input){
return (function (p1__13029_SHARP_){
var G__13035 = p1__13029_SHARP_;
var G__13035__$1 = cljs.core.assoc.call(null,G__13035,new cljs.core.Keyword(null,"input-text","input-text",-1336297114),new_text,new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),false)
;
if(cljs.core.truth_(re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"input-text-changed","input-text-changed",-1906799535)))){
return re_com.typeahead.update_model.call(null,G__13035__$1,new_text);
} else {
return G__13035__$1;
}
});})(map__13033,map__13033__$1,state,input_text,c_input))
);
}
});
re_com.typeahead.input_text_on_key_down_BANG_ = (function re_com$typeahead$input_text_on_key_down_BANG_(state_atom,event){
var pred__13039 = cljs.core._EQ_;
var expr__13040 = event.which;
if(cljs.core.truth_(pred__13039.call(null,goog.events.KeyCodes.UP,expr__13040))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_prev);
} else {
if(cljs.core.truth_(pred__13039.call(null,goog.events.KeyCodes.DOWN,expr__13040))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_next);
} else {
if(cljs.core.truth_(pred__13039.call(null,goog.events.KeyCodes.ENTER,expr__13040))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.choose_suggestion_active);
} else {
if(cljs.core.truth_(pred__13039.call(null,goog.events.KeyCodes.ESC,expr__13040))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.reset_typeahead);
} else {
if(cljs.core.truth_(pred__13039.call(null,goog.events.KeyCodes.TAB,expr__13040))){
if(cljs.core.truth_(cljs.core.not_empty.call(null,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,state_atom))))){
cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_next);

return event.preventDefault();
} else {
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.input_text_will_blur);
}
} else {
return true;
}
}
}
}
}
});
/**
 * typeahead reagent component
 */
re_com.typeahead.typeahead = (function re_com$typeahead$typeahead(var_args){
var args__7491__auto__ = [];
var len__7484__auto___13070 = arguments.length;
var i__7485__auto___13071 = (0);
while(true){
if((i__7485__auto___13071 < len__7484__auto___13070)){
args__7491__auto__.push((arguments[i__7485__auto___13071]));

var G__13072 = (i__7485__auto___13071 + (1));
i__7485__auto___13071 = G__13072;
continue;
} else {
}
break;
}

var argseq__7492__auto__ = ((((0) < args__7491__auto__.length))?(new cljs.core.IndexedSeq(args__7491__auto__.slice((0)),(0),null)):null);
return re_com.typeahead.typeahead.cljs$core$IFn$_invoke$arity$variadic(argseq__7492__auto__);
});

re_com.typeahead.typeahead.cljs$core$IFn$_invoke$arity$variadic = (function (p__13044){
var map__13045 = p__13044;
var map__13045__$1 = ((((!((map__13045 == null)))?((((map__13045.cljs$lang$protocol_mask$partition0$ & (64))) || (map__13045.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__13045):map__13045);
var args = map__13045__$1;
var data_source = cljs.core.get.call(null,map__13045__$1,new cljs.core.Keyword(null,"data-source","data-source",-658934676));
var on_change = cljs.core.get.call(null,map__13045__$1,new cljs.core.Keyword(null,"on-change","on-change",-732046149));
var rigid_QMARK_ = cljs.core.get.call(null,map__13045__$1,new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118));
var change_on_blur_QMARK_ = cljs.core.get.call(null,map__13045__$1,new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925));
if(cljs.core.truth_(((!(goog.DEBUG))?true:re_com.validate.validate_args.call(null,re_com.validate.extract_arg_data.call(null,re_com.typeahead.typeahead_args_desc),args,"typeahead")))){
} else {
throw (new Error("Assert failed: (validate-args-macro typeahead-args-desc args \"typeahead\")"));
}

var map__13047 = re_com.typeahead.make_typeahead_state.call(null,args);
var map__13047__$1 = ((((!((map__13047 == null)))?((((map__13047.cljs$lang$protocol_mask$partition0$ & (64))) || (map__13047.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__13047):map__13047);
var state = map__13047__$1;
var c_search = cljs.core.get.call(null,map__13047__$1,new cljs.core.Keyword(null,"c-search","c-search",1832536180));
var c_input = cljs.core.get.call(null,map__13047__$1,new cljs.core.Keyword(null,"c-input","c-input",-1821004232));
var state_atom = reagent.core.atom.call(null,state);
var input_text_model = reagent.core.cursor.call(null,state_atom,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input-text","input-text",-1336297114)], null));
re_com.typeahead.search_data_source_loop_BANG_.call(null,state_atom,c_search);

return ((function (map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_){
return (function() { 
var G__13073__delegate = function (p__13049){
var map__13050 = p__13049;
var map__13050__$1 = ((((!((map__13050 == null)))?((((map__13050.cljs$lang$protocol_mask$partition0$ & (64))) || (map__13050.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__13050):map__13050);
var args__$1 = map__13050__$1;
var disabled_QMARK_ = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"disabled?","disabled?",-1523234181));
var status_icon_QMARK_ = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"status-icon?","status-icon?",1328423612));
var height = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"height","height",1025178622));
var status_tooltip = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"status-tooltip","status-tooltip",1912159007));
var model = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"model","model",331153215));
var suggestion_to_string = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962));
var placeholder = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"placeholder","placeholder",-104873083));
var render_suggestion = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"render-suggestion","render-suggestion",1472406503));
var rigid_QMARK___$1 = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118));
var width = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"width","width",-384071477));
var data_source__$1 = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"data-source","data-source",-658934676));
var style = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"style","style",-496642736));
var status = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"status","status",-1997798413));
var class$ = cljs.core.get.call(null,map__13050__$1,new cljs.core.Keyword(null,"class","class",-2030961996));
if(cljs.core.truth_(((!(goog.DEBUG))?true:re_com.validate.validate_args.call(null,re_com.validate.extract_arg_data.call(null,re_com.typeahead.typeahead_args_desc),args__$1,"typeahead")))){
} else {
throw (new Error("Assert failed: (validate-args-macro typeahead-args-desc args \"typeahead\")"));
}

var map__13052 = cljs.core.deref.call(null,state_atom);
var map__13052__$1 = ((((!((map__13052 == null)))?((((map__13052.cljs$lang$protocol_mask$partition0$ & (64))) || (map__13052.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__13052):map__13052);
var state__$1 = map__13052__$1;
var suggestions = cljs.core.get.call(null,map__13052__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var waiting_QMARK_ = cljs.core.get.call(null,map__13052__$1,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215));
var suggestion_active_index = cljs.core.get.call(null,map__13052__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var external_model = cljs.core.get.call(null,map__13052__$1,new cljs.core.Keyword(null,"external-model","external-model",506095421));
var last_data_source = new cljs.core.Keyword(null,"data-source","data-source",-658934676).cljs$core$IFn$_invoke$arity$1(state__$1);
var latest_external_model = re_com.util.deref_or_value.call(null,model);
var width__$1 = (function (){var or__6409__auto__ = width;
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return "250px";
}
})();
if(cljs.core.not_EQ_.call(null,last_data_source,data_source__$1)){
cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.change_data_source,data_source__$1);
} else {
}

if(cljs.core.not_EQ_.call(null,latest_external_model,external_model)){
cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.external_model_changed,latest_external_model);
} else {
}

return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.v_box,new cljs.core.Keyword(null,"width","width",-384071477),width__$1,new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 27, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.misc.input_text,new cljs.core.Keyword(null,"model","model",331153215),input_text_model,new cljs.core.Keyword(null,"class","class",-2030961996),class$,new cljs.core.Keyword(null,"style","style",-496642736),style,new cljs.core.Keyword(null,"disabled?","disabled?",-1523234181),disabled_QMARK_,new cljs.core.Keyword(null,"status-icon?","status-icon?",1328423612),status_icon_QMARK_,new cljs.core.Keyword(null,"status","status",-1997798413),status,new cljs.core.Keyword(null,"status-tooltip","status-tooltip",1912159007),status_tooltip,new cljs.core.Keyword(null,"width","width",-384071477),width__$1,new cljs.core.Keyword(null,"height","height",1025178622),height,new cljs.core.Keyword(null,"placeholder","placeholder",-104873083),placeholder,new cljs.core.Keyword(null,"on-change","on-change",-732046149),cljs.core.partial.call(null,re_com.typeahead.input_text_on_change_BANG_,state_atom),new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925),false,new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"on-key-down","on-key-down",-1374733765),cljs.core.partial.call(null,re_com.typeahead.input_text_on_key_down_BANG_,state_atom)], null)], null),(cljs.core.truth_((function (){var or__6409__auto__ = cljs.core.not_empty.call(null,suggestions);
if(cljs.core.truth_(or__6409__auto__)){
return or__6409__auto__;
} else {
return waiting_QMARK_;
}
})())?new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.v_box,new cljs.core.Keyword(null,"class","class",-2030961996),"rc-typeahead-suggestions-container",new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.truth_(waiting_QMARK_)?new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.box,new cljs.core.Keyword(null,"align","align",1964212802),new cljs.core.Keyword(null,"center","center",-748944368),new cljs.core.Keyword(null,"child","child",623967545),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.misc.throbber,new cljs.core.Keyword(null,"size","size",1098693007),new cljs.core.Keyword(null,"small","small",2133478704),new cljs.core.Keyword(null,"class","class",-2030961996),"rc-typeahead-throbber"], null)], null):null),(function (){var iter__7189__auto__ = ((function (map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_){
return (function re_com$typeahead$iter__13054(s__13055){
return (new cljs.core.LazySeq(null,((function (map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_){
return (function (){
var s__13055__$1 = s__13055;
while(true){
var temp__4657__auto__ = cljs.core.seq.call(null,s__13055__$1);
if(temp__4657__auto__){
var s__13055__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__13055__$2)){
var c__7187__auto__ = cljs.core.chunk_first.call(null,s__13055__$2);
var size__7188__auto__ = cljs.core.count.call(null,c__7187__auto__);
var b__13057 = cljs.core.chunk_buffer.call(null,size__7188__auto__);
if((function (){var i__13056 = (0);
while(true){
if((i__13056 < size__7188__auto__)){
var vec__13064 = cljs.core._nth.call(null,c__7187__auto__,i__13056);
var i = cljs.core.nth.call(null,vec__13064,(0),null);
var s = cljs.core.nth.call(null,vec__13064,(1),null);
var selected_QMARK_ = cljs.core._EQ_.call(null,suggestion_active_index,i);
cljs.core.chunk_append.call(null,b__13057,cljs.core.with_meta(new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.box,new cljs.core.Keyword(null,"child","child",623967545),(cljs.core.truth_(render_suggestion)?render_suggestion.call(null,s):s),new cljs.core.Keyword(null,"class","class",-2030961996),[cljs.core.str("rc-typeahead-suggestion"),cljs.core.str(((selected_QMARK_)?" active":null))].join(''),new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"on-mouse-over","on-mouse-over",-858472552),((function (i__13056,selected_QMARK_,vec__13064,i,s,c__7187__auto__,size__7188__auto__,b__13057,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_){
return (function (){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_by_index,i);
});})(i__13056,selected_QMARK_,vec__13064,i,s,c__7187__auto__,size__7188__auto__,b__13057,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_))
,new cljs.core.Keyword(null,"on-mouse-down","on-mouse-down",1147755470),((function (i__13056,selected_QMARK_,vec__13064,i,s,c__7187__auto__,size__7188__auto__,b__13057,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_){
return (function (p1__13042_SHARP_){
p1__13042_SHARP_.preventDefault();

return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.choose_suggestion_by_index,i);
});})(i__13056,selected_QMARK_,vec__13064,i,s,c__7187__auto__,size__7188__auto__,b__13057,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_))
], null)], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"key","key",-1516042587),i], null)));

var G__13074 = (i__13056 + (1));
i__13056 = G__13074;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__13057),re_com$typeahead$iter__13054.call(null,cljs.core.chunk_rest.call(null,s__13055__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__13057),null);
}
} else {
var vec__13067 = cljs.core.first.call(null,s__13055__$2);
var i = cljs.core.nth.call(null,vec__13067,(0),null);
var s = cljs.core.nth.call(null,vec__13067,(1),null);
var selected_QMARK_ = cljs.core._EQ_.call(null,suggestion_active_index,i);
return cljs.core.cons.call(null,cljs.core.with_meta(new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.box,new cljs.core.Keyword(null,"child","child",623967545),(cljs.core.truth_(render_suggestion)?render_suggestion.call(null,s):s),new cljs.core.Keyword(null,"class","class",-2030961996),[cljs.core.str("rc-typeahead-suggestion"),cljs.core.str(((selected_QMARK_)?" active":null))].join(''),new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"on-mouse-over","on-mouse-over",-858472552),((function (selected_QMARK_,vec__13067,i,s,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_){
return (function (){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_by_index,i);
});})(selected_QMARK_,vec__13067,i,s,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_))
,new cljs.core.Keyword(null,"on-mouse-down","on-mouse-down",1147755470),((function (selected_QMARK_,vec__13067,i,s,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_){
return (function (p1__13042_SHARP_){
p1__13042_SHARP_.preventDefault();

return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.choose_suggestion_by_index,i);
});})(selected_QMARK_,vec__13067,i,s,s__13055__$2,temp__4657__auto__,map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_))
], null)], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"key","key",-1516042587),i], null)),re_com$typeahead$iter__13054.call(null,cljs.core.rest.call(null,s__13055__$2)));
}
} else {
return null;
}
break;
}
});})(map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_))
,null,null));
});})(map__13052,map__13052__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__13050,map__13050__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,suggestion_to_string,placeholder,render_suggestion,rigid_QMARK___$1,width,data_source__$1,style,status,class$,map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_))
;
return iter__7189__auto__.call(null,cljs.core.map.call(null,cljs.core.vector,cljs.core.range.call(null),suggestions));
})()], null)], null):null)], null)], null);
};
var G__13073 = function (var_args){
var p__13049 = null;
if (arguments.length > 0) {
var G__13075__i = 0, G__13075__a = new Array(arguments.length -  0);
while (G__13075__i < G__13075__a.length) {G__13075__a[G__13075__i] = arguments[G__13075__i + 0]; ++G__13075__i;}
  p__13049 = new cljs.core.IndexedSeq(G__13075__a,0);
} 
return G__13073__delegate.call(this,p__13049);};
G__13073.cljs$lang$maxFixedArity = 0;
G__13073.cljs$lang$applyTo = (function (arglist__13076){
var p__13049 = cljs.core.seq(arglist__13076);
return G__13073__delegate(p__13049);
});
G__13073.cljs$core$IFn$_invoke$arity$variadic = G__13073__delegate;
return G__13073;
})()
;
;})(map__13047,map__13047__$1,state,c_search,c_input,state_atom,input_text_model,map__13045,map__13045__$1,args,data_source,on_change,rigid_QMARK_,change_on_blur_QMARK_))
});

re_com.typeahead.typeahead.cljs$lang$maxFixedArity = (0);

re_com.typeahead.typeahead.cljs$lang$applyTo = (function (seq13043){
return re_com.typeahead.typeahead.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq13043));
});

/**
 * Return a channel which will receive a value from the `in` channel only
 *   if no further value is received on the `in` channel in the next `ms` milliseconds.
 */
re_com.typeahead.debounce = (function re_com$typeahead$debounce(in$,ms){
var out = cljs.core.async.chan.call(null);
var c__9975__auto___13243 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__9975__auto___13243,out){
return (function (){
var f__9976__auto__ = (function (){var switch__8768__auto__ = ((function (c__9975__auto___13243,out){
return (function (state_13210){
var state_val_13211 = (state_13210[(1)]);
if((state_val_13211 === (7))){
var inst_13165 = (state_13210[(2)]);
var state_13210__$1 = state_13210;
var statearr_13212_13244 = state_13210__$1;
(statearr_13212_13244[(2)] = inst_13165);

(statearr_13212_13244[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (1))){
var inst_13160 = null;
var state_13210__$1 = (function (){var statearr_13213 = state_13210;
(statearr_13213[(7)] = inst_13160);

return statearr_13213;
})();
var statearr_13214_13245 = state_13210__$1;
(statearr_13214_13245[(2)] = null);

(statearr_13214_13245[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (4))){
var state_13210__$1 = state_13210;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_13210__$1,(7),in$);
} else {
if((state_val_13211 === (15))){
var inst_13195 = (state_13210[(2)]);
var state_13210__$1 = (function (){var statearr_13215 = state_13210;
(statearr_13215[(8)] = inst_13195);

return statearr_13215;
})();
var statearr_13216_13246 = state_13210__$1;
(statearr_13216_13246[(2)] = null);

(statearr_13216_13246[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (13))){
var inst_13183 = (state_13210[(9)]);
var inst_13197 = cljs.core._EQ_.call(null,inst_13183,new cljs.core.Keyword(null,"default","default",-1987822328));
var state_13210__$1 = state_13210;
if(inst_13197){
var statearr_13217_13247 = state_13210__$1;
(statearr_13217_13247[(1)] = (16));

} else {
var statearr_13218_13248 = state_13210__$1;
(statearr_13218_13248[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (6))){
var inst_13169 = (state_13210[(10)]);
var inst_13168 = (state_13210[(2)]);
var inst_13169__$1 = cljs.core.async.timeout.call(null,ms);
var inst_13177 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_13178 = [in$,inst_13169__$1];
var inst_13179 = (new cljs.core.PersistentVector(null,2,(5),inst_13177,inst_13178,null));
var state_13210__$1 = (function (){var statearr_13219 = state_13210;
(statearr_13219[(10)] = inst_13169__$1);

(statearr_13219[(11)] = inst_13168);

return statearr_13219;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_13210__$1,(8),inst_13179);
} else {
if((state_val_13211 === (17))){
var state_13210__$1 = state_13210;
var statearr_13220_13249 = state_13210__$1;
(statearr_13220_13249[(2)] = null);

(statearr_13220_13249[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (3))){
var inst_13208 = (state_13210[(2)]);
var state_13210__$1 = state_13210;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_13210__$1,inst_13208);
} else {
if((state_val_13211 === (12))){
var inst_13168 = (state_13210[(11)]);
var state_13210__$1 = state_13210;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_13210__$1,(15),out,inst_13168);
} else {
if((state_val_13211 === (2))){
var inst_13160 = (state_13210[(7)]);
var inst_13162 = (inst_13160 == null);
var state_13210__$1 = state_13210;
if(cljs.core.truth_(inst_13162)){
var statearr_13221_13250 = state_13210__$1;
(statearr_13221_13250[(1)] = (4));

} else {
var statearr_13222_13251 = state_13210__$1;
(statearr_13222_13251[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (11))){
var inst_13205 = (state_13210[(2)]);
var inst_13160 = inst_13205;
var state_13210__$1 = (function (){var statearr_13223 = state_13210;
(statearr_13223[(7)] = inst_13160);

return statearr_13223;
})();
var statearr_13224_13252 = state_13210__$1;
(statearr_13224_13252[(2)] = null);

(statearr_13224_13252[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (9))){
var inst_13181 = (state_13210[(12)]);
var inst_13189 = cljs.core.nth.call(null,inst_13181,(0),null);
var inst_13190 = cljs.core.nth.call(null,inst_13181,(1),null);
var state_13210__$1 = (function (){var statearr_13225 = state_13210;
(statearr_13225[(13)] = inst_13190);

return statearr_13225;
})();
var statearr_13226_13253 = state_13210__$1;
(statearr_13226_13253[(2)] = inst_13189);

(statearr_13226_13253[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (5))){
var inst_13160 = (state_13210[(7)]);
var state_13210__$1 = state_13210;
var statearr_13227_13254 = state_13210__$1;
(statearr_13227_13254[(2)] = inst_13160);

(statearr_13227_13254[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (14))){
var inst_13203 = (state_13210[(2)]);
var state_13210__$1 = state_13210;
var statearr_13228_13255 = state_13210__$1;
(statearr_13228_13255[(2)] = inst_13203);

(statearr_13228_13255[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (16))){
var inst_13182 = (state_13210[(14)]);
var state_13210__$1 = state_13210;
var statearr_13229_13256 = state_13210__$1;
(statearr_13229_13256[(2)] = inst_13182);

(statearr_13229_13256[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (10))){
var inst_13183 = (state_13210[(9)]);
var inst_13169 = (state_13210[(10)]);
var inst_13192 = cljs.core._EQ_.call(null,inst_13183,inst_13169);
var state_13210__$1 = state_13210;
if(inst_13192){
var statearr_13230_13257 = state_13210__$1;
(statearr_13230_13257[(1)] = (12));

} else {
var statearr_13231_13258 = state_13210__$1;
(statearr_13231_13258[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (18))){
var inst_13201 = (state_13210[(2)]);
var state_13210__$1 = state_13210;
var statearr_13232_13259 = state_13210__$1;
(statearr_13232_13259[(2)] = inst_13201);

(statearr_13232_13259[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_13211 === (8))){
var inst_13181 = (state_13210[(12)]);
var inst_13183 = (state_13210[(9)]);
var inst_13181__$1 = (state_13210[(2)]);
var inst_13182 = cljs.core.nth.call(null,inst_13181__$1,(0),null);
var inst_13183__$1 = cljs.core.nth.call(null,inst_13181__$1,(1),null);
var inst_13184 = cljs.core._EQ_.call(null,inst_13183__$1,in$);
var state_13210__$1 = (function (){var statearr_13233 = state_13210;
(statearr_13233[(14)] = inst_13182);

(statearr_13233[(12)] = inst_13181__$1);

(statearr_13233[(9)] = inst_13183__$1);

return statearr_13233;
})();
if(inst_13184){
var statearr_13234_13260 = state_13210__$1;
(statearr_13234_13260[(1)] = (9));

} else {
var statearr_13235_13261 = state_13210__$1;
(statearr_13235_13261[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__9975__auto___13243,out))
;
return ((function (switch__8768__auto__,c__9975__auto___13243,out){
return (function() {
var re_com$typeahead$debounce_$_state_machine__8769__auto__ = null;
var re_com$typeahead$debounce_$_state_machine__8769__auto____0 = (function (){
var statearr_13239 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_13239[(0)] = re_com$typeahead$debounce_$_state_machine__8769__auto__);

(statearr_13239[(1)] = (1));

return statearr_13239;
});
var re_com$typeahead$debounce_$_state_machine__8769__auto____1 = (function (state_13210){
while(true){
var ret_value__8770__auto__ = (function (){try{while(true){
var result__8771__auto__ = switch__8768__auto__.call(null,state_13210);
if(cljs.core.keyword_identical_QMARK_.call(null,result__8771__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__8771__auto__;
}
break;
}
}catch (e13240){if((e13240 instanceof Object)){
var ex__8772__auto__ = e13240;
var statearr_13241_13262 = state_13210;
(statearr_13241_13262[(5)] = ex__8772__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_13210);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e13240;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__8770__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__13263 = state_13210;
state_13210 = G__13263;
continue;
} else {
return ret_value__8770__auto__;
}
break;
}
});
re_com$typeahead$debounce_$_state_machine__8769__auto__ = function(state_13210){
switch(arguments.length){
case 0:
return re_com$typeahead$debounce_$_state_machine__8769__auto____0.call(this);
case 1:
return re_com$typeahead$debounce_$_state_machine__8769__auto____1.call(this,state_13210);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
re_com$typeahead$debounce_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$0 = re_com$typeahead$debounce_$_state_machine__8769__auto____0;
re_com$typeahead$debounce_$_state_machine__8769__auto__.cljs$core$IFn$_invoke$arity$1 = re_com$typeahead$debounce_$_state_machine__8769__auto____1;
return re_com$typeahead$debounce_$_state_machine__8769__auto__;
})()
;})(switch__8768__auto__,c__9975__auto___13243,out))
})();
var state__9977__auto__ = (function (){var statearr_13242 = f__9976__auto__.call(null);
(statearr_13242[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__9975__auto___13243);

return statearr_13242;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__9977__auto__);
});})(c__9975__auto___13243,out))
);


return out;
});

//# sourceMappingURL=typeahead.js.map?rel=1499873946521